from cml.domain.reconstruction import (
    split,
    valid_reconstructed,
    Metadata,
    PragmaticMachineLearningModel,
    InterimPragmatic)


MODEL_COUNTERS = None


def set_valid_counter(length):
    global MODEL_COUNTERS
    MODEL_COUNTERS = [i for i in range(1, length+1)]


def reconstruct_in_parallel(*args):
    dto = args[0]
    train_block, eval_block = split(dto.learnblock, dto.settings.reliability_sample)
    trained_model = dto.model.train(train_block.as_numpy_array(),
                                    [i for i in train_block.get_column("Z")])
    if valid_reconstructed(trained_model, "conceptual", dto.settings):
        zeta = ".".join([dto.abv,
                        str(dto.tier),
                        dto.learnblock.subject])
        meta = Metadata(dto.abv,
                        dto.tier,
                        dto.count,
                        dto.learnblock.indices(),
                        dto.learnblock.columns(),
                        dto.learnblock.get_column("Z"),
                        dto.learnblock.min_timestamp(),
                        dto.learnblock.max_timestamp(),
                        (dto.model.subject,),
                        (zeta,))
        pragmatic = PragmaticMachineLearningModel(meta, trained_model, dto.learnblock)
        predictions = trained_model.predict(eval_block.as_numpy_array())
        return InterimPragmatic(pragmatic, predictions, dto.learnblock)

    return None, None
